package ExemplesJDBC.GererPrets;
import java.sql.*;
// La classe CourtierBDExemplaire est un intermdaire qui encapsule les interactions avec la BD
public class CourtierBDExemplaire {
    private Connection uneConnection;
   
    // Constructeur pour connexion passe par le crateur
    public CourtierBDExemplaire(Connection laConnection){
        this.uneConnection = laConnection;
    }
    
    public void setConnection(Connection laConnection){
        this.uneConnection = laConnection;
    }

    public Exemplaire chercherExemplaireParIdExemplaire(String idExemplaire)
    // Ne considre pas les rfrences au Livre et aux Prts
        throws Exception {
        // Verrouillage de l'exemplaire (FOR UPDATE)pour srialisabilit 
        // (Oracle mode READ COMMITTED)
        PreparedStatement unEnoncSQL = uneConnection.prepareStatement
        ("SELECT statut FROM Exemplaire WHERE idExemplaire = ? FOR UPDATE");
        unEnoncSQL.setString(1,idExemplaire);
        ResultSet rsultatSelect = unEnoncSQL.executeQuery();
        if (rsultatSelect.next()){
            Exemplaire unExemplaire = 
                new Exemplaire(
                    idExemplaire,
                    rsultatSelect.getString("statut"));
            unEnoncSQL.close();
            return unExemplaire;
        }else{
            unEnoncSQL.close();
            throw new Exception("Exemplaire inexistant");
        }
    }
}