package ExemplesJDBC.GererPrets;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;

public class ServletEnregistrerPrets extends HttpServlet {

  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException{
    //Chercher le paramtre idUtilisateur de la FORM HTML
    String idUtilisateur = "";
    try { idUtilisateur = request.getParameter("idUtilisateur"); }
    catch (Exception e) { e.printStackTrace(); }
    //Chercher le paramtre idExemplaire de la FORM HTML
    String idExemplaire = "";
    try { idExemplaire = request.getParameter("idExemplaire"); }
    catch (Exception e) { e.printStackTrace(); }

    // Entte de la page de rponse HTML
    response.setContentType("text/html");
    OutputStreamWriter unOutputStreamWriter = new OutputStreamWriter(response.getOutputStream());
    PrintWriter out = new PrintWriter(unOutputStreamWriter);
    out.println("<html>");
    out.println("<head><title>Rponse de ServletEnregistrerPrets</title></head>");
    out.println("<body>");

    UsineConnection uneUsineConnection = new UsineConnection();
    Connection uneConnection = null;
    try{
      // Ouvrir une Connection
      uneConnection = uneUsineConnection.getConnectionSansAutoCommit(
            "oracle.jdbc.driver.OracleDriver",
            "jdbc:oracle:thin:@localhost:1521:ora817i",
            "clerat","oracle");
      // Dmatrialiser l'Utilisateur et ses PrtsEnCours
      Membre unMembre = null;

      // Cration du courtier et dmatrialisation de l'Utilisateur
      CourtierBDUtilisateur unCourtierBDUtilisateur =
        new CourtierBDUtilisateur(uneConnection);
      Utilisateur unUtilisateur = unCourtierBDUtilisateur.chercherUtilisateurParIdUtilisateur(idUtilisateur);

      //Cration du courtier et dmatrialisation des PrtsEnCours
      CourtierBDPrtEnCours unCourtierBDPrtEnCours =
        new CourtierBDPrtEnCours(uneConnection);
      unCourtierBDPrtEnCours.chercherLesPrtsEnCoursEtExemplaires(unUtilisateur);

      // Affichage de l'idUtilisateur et du nombre de prts
      out.println("Utilisateur :" + idUtilisateur);
      out.println(" Nombre de prts en cours :" + unUtilisateur.getNbPrtsEnCours()+"<br>");

      // Vrifier si les conditions pralables sont violes
      boolean conditionsAcceptes = false;
      if (unUtilisateur instanceof Membre){
        unCourtierBDUtilisateur.chercherVariablesStatiquesDeMembre();
        unMembre = (Membre)unUtilisateur;
        if (!unMembre.conditionsPrtAcceptes()){
          out.println("Prt refus.<br>Nb de prts :" + unMembre.getNbPrtsEnCours()+
                ". Maximum :" + Membre.getNbMaxPrts() +
                ". Nb de retards :" + unMembre.getNbRetards());
        }else {conditionsAcceptes = true;}
      }else{conditionsAcceptes = true;}// Pas de contrainte pour un employ
      if(conditionsAcceptes){
        // Vrifier statut de l'exemplaire
        CourtierBDExemplaire unCourtierBDExemplaire =
          new CourtierBDExemplaire(uneConnection);
        Exemplaire unExemplaire = unCourtierBDExemplaire.chercherExemplaireParIdExemplaire(idExemplaire);
        if (unExemplaire.getStatut().equals("disponible")){

          // Gnrer la date du jour et l'objet PrtEnCours
          Calendar maintenant = Calendar.getInstance(); // Calendrier avec date actuelle
          java.sql.Date dateMaintenant = new java.sql.Date(maintenant.getTime().getTime());
          PrtEnCours leNouveauPrtEnCours = new PrtEnCours(unUtilisateur,dateMaintenant,unExemplaire);

          // Matrialiser le PrtEnCours dans la BD
          unCourtierBDPrtEnCours.insrerPrtEnCours(leNouveauPrtEnCours);

          // Message de confirmation du prt
          out.println("Prt de l'exemplaire " + idExemplaire +
                "  l'utilisateur " + idUtilisateur + " confirm.<br>Date :" + dateMaintenant);
        }else{
          // Message indiquant que l'exemplaire n'est pas disponible pour le prt
          out.println("Exemplaire non disponible:"+idExemplaire);
        }
      }
    }
    catch(Exception lException){
      out.println(lException.getMessage());
      lException.printStackTrace();
    }
    finally{
      try{
        out.println("</body></html>");
        out.close();
        uneConnection.commit();
        uneConnection.close();
      }
      catch(Exception lException){
      lException.printStackTrace();
      }
    }
  }
}
